
import java.io.*;
import java.util.*;
import pqrtree.*;

public class PQRInterface {
	public static void main(String[] args) 
	{
		BufferedReader	inReader = null;
        String inFile, line;
        int size = 0;
        int[][] collection = null;
        int setlengthsum = 0;
        inFile = args[0];
        try {
            inReader = new BufferedReader(new FileReader(inFile));
        } catch( FileNotFoundException e ) {
            System.err.println("No pode abrir " + inFile);
            System.exit(1);
        }
        try {
        	line = inReader.readLine();
        	size = Integer.parseInt(line);
        	collection = new int[Integer.parseInt(inReader.readLine())][];
        	for (int j = 0; j<collection.length; j++)
        	{
        		StringTokenizer st = new StringTokenizer(inReader.readLine());
        		int[] set = new int[Integer.parseInt(st.nextToken())];
        		setlengthsum += set.length;
        		for (int i = 0; i<set.length; i++)
        		{
        			set[i] = Integer.parseInt(st.nextToken());
        		}
        		collection[j] = set;
        	}
        	
            inReader.close();
        } catch (IOException e) {
            System.err.println(e.getMessage());
        }
        
        Object[] u = new Object[size];
        for (int i = 0; i<size; i++)
        {
        	u[i]= new Integer(i);
        }
        
        System.out.println(size);
        System.out.println(collection.length);
        System.out.println(setlengthsum);
        System.out.println(size+collection.length+setlengthsum);
        
        PQRTree tree = new PQRTree(u, collection);
        System.out.println(tree.frontier());
        System.out.println(tree.preOrder());
        try {
        	FileWriter writer = new FileWriter("out.txt", true); //append mode
        	PrintWriter out = new PrintWriter(writer,true);
        	out.println(inFile);
        	out.println(tree.preOrder());
        } catch( IOException e ) {
            System.err.println("Couldn't open file " + inFile);
            System.exit(1);
        }
	}
}
