import java.io.*;
import java.util.*;

public class ProblemsCreator {
	public static void main(String[] args) {
		//gets max and min values of universe size, collection
		String dir = args[0];
		int num_tests = Integer.parseInt(args[1]);
		int max_u = Integer.parseInt(args[2]);
		int min_u = Integer.parseInt(args[3]);
		int max_c = Integer.parseInt(args[4]);
		int min_c = Integer.parseInt(args[5]);
		
		for (int i = 0; i<num_tests; i++)
		{
			try 
			{
				FileWriter writer = new FileWriter(dir + "/test"+ String.valueOf(i) , true); //append mode
				PrintWriter out = new PrintWriter(writer,true);
				
				Random generator = new Random();
				//choose a random value to universe size, and collection
				int u = generator.nextInt(max_u - min_u + 1) + min_u;
				int c = generator.nextInt(max_c - min_c + 1) + min_c;
				
				//write the to the file
				out.println(String.valueOf(u));
				out.println(String.valueOf(c));
				
				//creates the universe set
				Vector universe = new Vector();
		        for (int j = 0; j<u; j++)
		        {
		        	universe.addElement(new Integer(j));
		        }
				
				//for each set in collection, choose a random size
				for (int k=0; k<c; k++)
				{
					int size = generator.nextInt(u + 1);
					out.print(String.valueOf(size)+" ");
					//creates a copy of the universe
					Vector copy;
					copy = (Vector)universe.clone();
					
					//so gets the random size of elements and put into the empty list
					for (int t=0; t<size; t++)
					{
						int index = generator.nextInt(u - t);
						int elem = Integer.parseInt(copy.remove(index).toString());
						out.print(String.valueOf(elem)+" ");
					}
					
					out.println();
				}
			} 
			catch( IOException e ) 
			{
				System.err.println("Couldn't create a new file");
				System.exit(1);
			}
		}
		
	}	
}
